ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.4 by root, Wed Mar 7 20:30:18 2007 UTC vs.
Revision 1.51 by root, Sat Aug 18 20:39:14 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
19use File::Temp; 20use File::Temp;
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
24use Coro::Util;
23use POSIX (); 25use POSIX ();
26use Digest::MD5;
27use Carp;
28use Coro::Storable; $Storable::canonical = 1;
29
30$SIG{QUIT} = sub { Carp::cluck "QUIT" };
24 31
25sub usage { 32sub usage {
26 warn <<EOF; 33 warn <<EOF;
27Usage: cfutil [-v] [-q] [--force] [--cache] 34Usage: cfutil [-v] [-q] [--force] [--cache]
28 [--install-arch path] 35 [--install-arch path]
40my $CACHE = 0; 47my $CACHE = 0;
41my $FORCE; 48my $FORCE;
42my $TMPDIR = "/tmp/cfutil$$~"; 49my $TMPDIR = "/tmp/cfutil$$~";
43my $TMPFILE = "aaaa0"; 50my $TMPFILE = "aaaa0";
44 51
52our %COLOR = (
53 black => 0,
54 white => 1,
55 navy => 2,
56 red => 3,
57 orange => 4,
58 blue => 5,
59 darkorange => 6,
60 green => 7,
61 lightgreen => 8,
62 grey => 9,
63 brown => 10,
64 gold => 11,
65 tan => 12,
66);
67
45END { system "rm", "-rf", $TMPDIR } 68END { system "rm", "-rf", $TMPDIR }
46 69
47Event->signal (signal => "INT", cb => sub { exit 1 }); 70Event->signal (signal => "INT", cb => sub { exit 1 });
48Event->signal (signal => "TERM", cb => sub { exit 1 }); 71Event->signal (signal => "TERM", cb => sub { exit 1 });
49 72
66} 89}
67 90
68sub inst_maps($) { 91sub inst_maps($) {
69 my (undef, $path) = @_; 92 my (undef, $path) = @_;
70 93
71 print "installing '$path' to '$DATADIR/maps'\n\n"; 94 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
72 95
73 if (!-f "$path/regions") { 96 if (!-f "$path/regions") {
74 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 97 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
75 exit 1 unless $FORCE; 98 exit 1 unless $FORCE;
76 } 99 }
77 100
78 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 101 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
102 and die "map installation failed.\n";
103
104 print "maps installed successfully.\n";
79} 105}
80 106
81{ 107{
82 our @PNG; 108 our %ANIMINFO;
109 our %FACEINFO;
110 our %RESOURCE;
83 our @ARC; 111 our @ARC;
112 our %ARC;
113 our $TRS;
84 our $NFILE; 114 our $NFILE;
115 our $PATH;
85 116
117 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
118
86 our (@png, @trs, @arc); # files we are interested in 119 our (@png, @trs, @arc, @res); # files we are interested in
87 120
88 sub commit_png { 121 sub commit_png($$$) {
89 my ($name, $data) = @_; 122 my ($name, $data, $T) = @_;
90 #warn "$name: commited\n"; 123
124 $FACEINFO{$name}{"data$T"} = $data;
91 } 125 }
92 126
93 sub process_png { 127 sub process_png {
94 while (@png) { 128 while (@png) {
95 my $path = pop @png; 129 my ($path, $delete) = @{pop @png};
96 130
97 my $png; 131 my $png;
98 aio_lstat $path; 132 aio_lstat $path;
99 my ($size, $mtime) = (stat _)[7,9]; 133 my ($size, $mtime) = (stat _)[7,9];
100 134
101 if (0 > aio_load $path, $png) { 135 if (0 > aio_load $path, $png) {
102 warn "$path: $!, skipping.\n"; 136 warn "$path: $!, skipping.\n";
103 return; 137 next;
104 } 138 }
105 139
140 my $stem = $path;
141 my $T;
142
143 if ($stem =~ s/\.32x32\.png~?$//) {
144 $T = 32;
145 } elsif ($stem =~ s/\.64x64\.png~?$//) {
146 $T = 64;
147 } else {
148 warn "$path: weird filename, skipping.\n";
149 next;
150 }
151
106 # quickly extratc width and height of the (necessarily PNG) image 152 # quickly extract width and height of the (necessarily PNG) image
107 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 153 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
108 warn "$path: not a recongized png file, skipping.\n"; 154 warn "$path: not a recognized png file, skipping.\n";
109 return; 155 next;
110 } 156 }
111 157
112 my ($w, $h) = unpack "NN", $1; 158 my ($w, $h) = unpack "NN", $1;
113
114 (my $face = $path) =~ s/^.*\///;
115 my $T = 32;
116
117 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
118 warn "$path: weird filename, skipping.\n";
119 return;
120 }
121 159
122 if ($w < $T || $h < $T) { 160 if ($w < $T || $h < $T) {
123 warn "$path: too small ($w $h), skipping.\n"; 161 warn "$path: too small ($w $h), skipping.\n";
124 return; 162 next;
125 } 163 }
126 164
127 if ($w % $T || $h % $T) { 165 if ($w % $T || $h % $T) {
128 warn "$path: weird png size ($w $h), skipping.\n"; 166 warn "$path: weird png size ($w $h), skipping.\n";
129 return; 167 next;
168 }
169
170 unless ($path =~ /~$/) {
171 # possibly enlarge
172 if (0 > aio_stat "$stem.64x64.png") {
173 my $other = "$stem.64x64.png~";
174
175 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
176 fork_sub {
177 system "convert -depth 8 png:\Q$path\E rgba:-"
178 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~"
180 and die "convert/hq2xa pipeline error: status $? ($!)";
181 system $OPTIPNG, "-i0", "-q", "$other~";
182 die "$other~ has zero size, aborting." unless -s "$other~";
183 rename "$other~", $other;
184 };
185 }
186
187 push @png, [$other, !$CACHE];
130 } 188 }
131 189
190 # possibly scale down
191 if (0 > aio_stat "$stem.32x32.png") {
192 my $other = "$stem.32x32.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
197 system $OPTIPNG, "-i0", "-q", "$other~";
198
199 # reduce smoothfaces >10000 bytes
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256;
202 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~";
206 $ncolor = int $ncolor * 0.9;
207 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
208 }
209
210 printf "reduced %s from %d to %d bytes using %d colours.\n",
211 $other, -s "$other~", -s "$other~~", $ncolor
212 if $VERBOSE >= 2;
213 rename "$other~~", "$other~";
214 }
215
216 die "$other~ has zero size, aborting." unless -s "$other~";
217 rename "$other~", $other;
218 };
219 }
220
221 #warn "scaled down $path to $other\n";#d#
222 push @png, [$other, !$CACHE];
223 }
224 }
225
226 (my $face = $stem) =~ s/^.*\///;
227
228 # split all bigfaces, but avoid smoothfaces (*_S)
132 if (($w > $T || $h > $T) && $face !~ /_S\./) { 229 if (($w > $T || $h > $T) && $face !~ /_S\./) {
133 # split 230 # split
134 my @tile; 231 my @tile;
135 for my $x (0 .. (int $w / $T) - 1) { 232 for my $x (0 .. (int $w / $T) - 1) {
136 for my $y (0 .. (int $h / $T) - 1) { 233 for my $y (0 .. (int $h / $T) - 1) {
149 (map { 246 (map {
150 ( 247 (
151 "(", 248 "(",
152 "+clone", 249 "+clone",
153 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 250 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
251 "+repage",
252 -quality => "00",
154 -write => "png:$_->[2]~", 253 -write => "png32:$_->[2]~",
155 "+delete", 254 "+delete",
156 ")", 255 ")",
157 ) 256 )
158 } @todo), 257 } @todo),
159 "null:"; 258 "null:";
163 close $convert; 262 close $convert;
164 263
165 # pass 2, optimise, and rename 264 # pass 2, optimise, and rename
166 for (@todo) { 265 for (@todo) {
167 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 266 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
267 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
168 rename "$_->[2]~", $_->[2]; 268 rename "$_->[2]~", $_->[2];
169 } 269 }
170 }; 270 };
171 } 271 }
172 272
176 276
177 if (0 > aio_load $file, $tile) { 277 if (0 > aio_load $file, $tile) {
178 die "$path: unable to read tile +$x+$y, aborting.\n"; 278 die "$path: unable to read tile +$x+$y, aborting.\n";
179 } 279 }
180 IO::AIO::aio_unlink $file unless $CACHE; 280 IO::AIO::aio_unlink $file unless $CACHE;
181 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 281 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
182 } 282 }
183 } else { 283 } else {
184 # use as-is (either small, use smooth) 284 # use as-is (either small, use smooth)
185 commit_png $face, $png; 285 commit_png $face, $png, $T;
186 } 286 }
287
288 aio_unlink $path if $delete;
187 } 289 }
188 } 290 }
189 291
190 sub process_arc { 292 sub process_arc {
191 while (@arc) { 293 while (@arc) {
195 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
196 298
197 my $arc = read_arch "$dir/$file"; 299 my $arc = read_arch "$dir/$file";
198 for my $o (values %$arc) { 300 for my $o (values %$arc) {
199 push @ARC, $o; 301 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m;
304 }
305
306 $o->{editor_folder} = $dir;
307
308 my $visibility = delete $o->{visibility};
309 my $magicmap = delete $o->{magicmap};
310
311 # find upper left corner :/
312 # omg, this is sooo broken
200 my ($dx, $dy); 313 my ($dx, $dy);
201 # omg, this is sooo broken
202 for (my $o = $o; $o; $o = $o->{more}) { 314 for (my $o = $o; $o; $o = $o->{more}) {
203 $dx = $o->{x} if $o->{x} < $dx; 315 $dx = $o->{x} if $o->{x} < $dx;
204 $dy = $o->{y} if $o->{y} < $dy; 316 $dy = $o->{y} if $o->{y} < $dy;
205 } 317 }
318
206 for (my $o = $o; $o; $o = $o->{more}) { 319 for (my $o = $o; $o; $o = $o->{more}) {
207 my $x = $o->{x} - $dx; 320 my $x = $o->{x} - $dx;
208 my $y = $o->{y} - $dy; 321 my $y = $o->{y} - $dy;
322
323 my $ext = $x|$y ? "+$x+$y" : "";
324
325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
326
327 $visibility = delete $o->{visibility} if exists $o->{visibility};
328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
329
330 my $anim = delete $o->{anim};
331
209 if ($x|$y) { 332 if ($anim) {
210 $_ .= "+$x+$y" for $o->{face}, @{$o->{anim} || []}; 333 # possibly add $ext to the animation name to avoid
334 # the need to specify archnames for all parts
335 # of a multipart archetype.
336 $o->{animation} = "$o->{_name}";
337 my $facings = 1;
338 my @frames;
339
340 for (@$anim) {
341 if (/^facings\s+(\d+)/) {
342 $facings = $1*1;
343 } elsif (/^blank.x11$|^empty.x11$/) {
344 push @frames, $_;
345 } else {
346 push @frames, "$_$ext";
347 }
348 }
349
350 $ANIMINFO{$o->{animation}} = {
351 facings => $facings,
352 frames => \@frames,
353 };
354 }
355
356 for my $face ($o->{face} || (), @{$anim || []}) {
357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
358
359 my $info = $FACEINFO{$face} ||= {};
360
361 $info->{visibility} = $visibility if defined $visibility;
362 $info->{magicmap} = $magicmap if defined $magicmap;
363 }
364
365 if (my $smooth = delete $o->{smoothface}) {
366 my %kv =split /\s+/, $smooth;
367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
368 while (my ($face, $smooth) = each %kv) {
369 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level;
371 }
211 } 372 }
212 } 373 }
213 } 374 }
214 } 375 }
215 } 376 }
216 377
217 sub process_trs { 378 sub process_trs {
218 while (@trs) { 379 while (@trs) {
219 my ($dir, $file) = @{pop @trs}; 380 my ($dir, $file) = @{pop @trs};
381 my $path = "$dir/$file";
382
383 my $trs;
384 if (0 > aio_load $path, $trs) {
385 warn "$path: $!, skipping.\n";
386 next;
387 }
388
389 $TRS .= $trs;
390 }
391 }
392
393 my %FILECACHE;
394
395 sub load_cached($;$) {
396 unless (exists $FILECACHE{$_[0]}) {
397 my $data;
398 if (0 < aio_load $_[0], $data) {
399 if ($_[1]) {
400 $data = eval { $_[1]->($data) };
401 warn "$_[0]: $@" if $@;
402 }
403 }
404
405 $FILECACHE{$_[0]} = $data;
406 }
407
408 $FILECACHE{$_[0]}
409 }
410
411 sub process_res {
412 while (@res) {
413 my ($dir, $file, $type) = @{pop @res};
414
415 my $data;
416 aio_load "$dir/$file", $data;
417
418 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
419
420 next if $meta && !exists $meta->{$file};
421
422 $meta = {
423 %{ $meta->{"" } || {} },
424 %{ $meta->{$file} || {} },
425 };
426
427 if ($meta->{license} =~ s/^#//) {
428 $meta->{license} = ({
429 "pd" => "Public Domain",
430 "gpl" => "GNU General Public License, version 3.0 or any later",
431 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
432 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
433 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
434 })->{$meta->{license}}
435 || warn "$dir/$file: license tag '$meta->{license}' not found.";
436 }
437
438 $file =~ s/\.res$//;
439 $file =~ s/\.(ogg|wav|jpg|png)$//;
440
441 substr $dir, 0, 1 + length $PATH, "";
442
443 $RESOURCE{"$dir/$file"} = {
444 type => (delete $meta->{type}) || $type,
445 data => $data,
446 chksum => (Digest::MD5::md5 $data),
447 %$meta ? (meta => $meta) : (),
448 };
220 } 449 }
221 } 450 }
222 451
223 sub find_files; 452 sub find_files;
224 sub find_files { 453 sub find_files {
229 my ($dirs, $nondirs) = @_; 458 my ($dirs, $nondirs) = @_;
230 459
231 find_files "$path/$_" 460 find_files "$path/$_"
232 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 461 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
233 462
463 my $dir = $path;
464 substr $dir, 0, 1 + length $PATH, "";
465
234 for my $file (@$nondirs) { 466 for my $file (@$nondirs) {
467 if ($dir =~ /^music(?:\/|$)/) {
468 push @res, [$path, $file, 3] # FT_MUSIC
469 if $file =~ /\.(ogg)$/;
470
471 } elsif ($dir =~ /^sound(?:\/|$)/) {
472 push @res, [$path, $file, 5] # FT_SOUND
473 if $file =~ /\.(wav|ogg)$/;
474
475 } elsif ($dir =~ /^res(?:\/|$)/) {
476 push @res, [$path, $file, 0] # FT_FACE
477 if $file =~ /\.(jpg|png)$/;
478 push @res, [$path, $file, 7] # FT_RSRC
479 if $file =~ /\.(res)$/;
480
235 if ($file =~ /\.png$/) { 481 } elsif ($file =~ /\.png$/) {
236 push @png, "$path/$file"; 482 push @png, ["$path/$file", 0];
483
237 } elsif ($file =~ /\.trs$/) { 484 } elsif ($file =~ /\.trs$/) {
238 push @trs, [$path, $file]; 485 push @trs, [$path, $file];
486
239 } elsif ($file =~ /\.arc$/) { 487 } elsif ($file =~ /\.arc$/) {
240 push @arc, [$path, $file]; 488 push @arc, [$path, $file];
489
241 } else { 490 } else {
242 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 491 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
243 } 492 }
244 } 493 }
245 }; 494 };
246 } 495 }
247 496
248 sub inst_arch($) { 497 sub inst_arch($) {
249 my (undef, $path) = @_; 498 my (undef, $path) = @_;
250 499
500 $PATH = $path;
501
502 print "\n",
251 print "installing '$path' to '$DATADIR'\n\n"; 503 "Installing '$path' to '$DATADIR'\n",
504 "\n",
505 "This can take a long time if you run this\n",
506 "for the first time or do not use --cache.\n",
507 "\n",
508 "Unless you run verbosely, all following warning\n",
509 "or error messages indicate serious problems.\n",
510 "\n";
252 511
253 if (!-d "$path/treasures") { 512 if (!-d "$path/treasures") {
254 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 513 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
255 exit 1 unless $FORCE; 514 exit 1 unless $FORCE;
256 } 515 }
257 516
258 find_files $path; 517 find_files $path;
259 IO::AIO::flush; 518 IO::AIO::flush;
260 519
261 $_->join for ( 520 $_->join for (
262 (async \&process_png), (async \&process_png), 521 # four png crunchers work fine for my 2x smp machine
522 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
263 (async \&process_trs), (async \&process_trs), 523 (async \&process_trs), (async \&process_trs),
264 (async \&process_arc), (async \&process_arc), 524 (async \&process_arc), (async \&process_arc),
525 (async \&process_res), (async \&process_res),
265 ); 526 );
266 527
528 {
529 # remove path prefix from editor_folder
530 substr $_->{editor_folder}, 0, 1 + length $path, ""
531 for values %ARC;
532
533 # resolve inherit
534 while () {
535 my $progress;
536 my $loop;
537
538 for my $o (values %ARC) {
539 if (my $other = $o->{inherit}) {
540 if (my $s = $ARC{$other}) {
541 if ($s->{inherit}) {
542 $loop = $s;
543 } else {
544 delete $o->{inherit};
545 my %s = %$s;
546 delete @s{qw(_name more name name_pl)};
547 %$o = ( %s, %$o );
548 ++$progress;
549 }
550 } else {
551 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
552 delete $ARC{$o->{_name}};
553 }
554 }
555 }
556
557 unless ($progress) {
558 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
559 if $loop;
560
561 last;
562 }
563 }
564
565 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
566 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
567
267 open my $archetypes, ">:utf8", "$DATADIR/archetypes~" 568 open my $fh, ">:utf8", "$DATADIR/archetypes~"
268 or die "$DATADIR/archetypes~: $!"; 569 or die "$DATADIR/archetypes~: $!";
269 print $archetypes Crossfire::archlist_to_string \@ARC; 570 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
270 close $archetypes; 571 }
271 rename "$DATADIR/archetypes~", "$DATADIR/archetypes";
272 572
273 die "--install-arch not fully implemented\n"; 573 {
574 open my $fh, ">:utf8", "$DATADIR/treasures~"
575 or die "$DATADIR/treasures~: $!";
576 print $fh $TRS;
577 }
578
579 {
580 while (my ($k, $v) = each %FACEINFO) {
581 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
582 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
583
584 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
585 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
586
587 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
588 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
589
590 if (my $magicmap = $v->{magicmap}) {
591 $magicmap =~ y/A-Z_\-/a-z/d;
592 $v->{magicmap} = $COLOR{$magicmap};
593 }
594 }
595
596 open my $fh, ">:perlio", "$DATADIR/facedata~"
597 or die "$DATADIR/facedata~: $!";
598
599 print $fh freeze {
600 version => 2,
601 faceinfo => \%FACEINFO,
602 animinfo => \%ANIMINFO,
603 resource => \%RESOURCE,
604 };
605 }
606
607 for (qw(archetypes facedata treasures)) {
608 chmod 0644, "$DATADIR/$_~";
609 rename "$DATADIR/$_~", "$DATADIR/$_"
610 or die "$DATADIR/$_: $!";
611 }
612
613 print "archetype data installed successfully.\n";
274 } 614 }
275} 615}
276 616
277Getopt::Long::Configure ("bundling", "no_ignore_case"); 617Getopt::Long::Configure ("bundling", "no_ignore_case");
278GetOptions ( 618GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines